#!/usr/bin/env python
#*******************************************************************************#
#    This program is free software; you can redistribute it and/or modify
#    it under the terms of the GNU General Public License as published by
#    the Free Software Foundation; either version 2 of the License, or
#    (at your option) any later version.
#
#    This program is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#    GNU General Public License for more details.
#
#    You should have received a copy of the GNU General Public License along
#    with this program; if not, write to the Free Software Foundation, Inc.,
#    51 Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA.
#*******************************************************************************#

import socket ,pygame, os, threading, Tkinter, sys, time, gettext


class lanchat():
	def __init__(self):
		self.hosts = [] 
		self.client_socket = ""
		self.ip = ""
		self.nick = ""
		self.Version = "1.3.0"
		gettext.install("lanchat", localedir="./")

		self.client_socket  = socket.socket(socket.AF_INET, socket.SOCK_STREAM)
		self.thread_listen = threading.Thread(target=self.listen_messages, args=())
		
		#**** Archivos... *****************************
		#----------------------------------------------
		#**** Files... ******************************** 
		file_hosts = open(os.path.realpath("data/config/hosts.txt"), "r")
		while True:
			line = file_hosts.readline()
			if not line:
				break
			self.hosts.append(line) 
		file_hosts.close()

		file_nick = open(os.path.realpath("data/config/nick.txt"), "r")
		self.nick = file_nick.readline()
		file_nick.close()

		#**** Interface grafica ***********************
		#----------------------------------------------
		#**** GUI ************************************* 
		self.Parent = Tkinter.Tk()
		self.Parent.geometry("560x440")
		self.Parent.resizable(False, False)
		self.Parent.title("lanChat")
		
		self.top_container = Tkinter.Frame(self.Parent)
		self.top_container.pack()
		self.middle_container = Tkinter.Frame(self.Parent)
		self.middle_container.pack()
		self.bottom_container = Tkinter.Frame(self.Parent)
		self.bottom_container.pack()

		self.label_sent = Tkinter.Label(self.top_container, anchor=Tkinter.W)
		self.label_sent["text"] = _("Sent --- ")
		#self.label_sent["font"] = "Helvetica 14"
		self.label_sent.pack(side=Tkinter.LEFT)
		
		self.label_received = Tkinter.Label(self.top_container, anchor=Tkinter.E)
		self.label_received["text"] = _(" --- Received")
		#self.label_received["font"] = "Helvetica 14"
		self.label_received.pack(side=Tkinter.RIGHT)

		#**** los mensajes que enviamos ***************
		#----------------------------------------------
		#**** sent messages ***************************
		self.display_message_output = Tkinter.Text(self.middle_container)
		self.display_message_output["width"] = 30
		self.display_message_output["height"] = 20
		self.display_message_output["wrap"] = "word"
		self.vertical_scrollbar_out = Tkinter.Scrollbar(self.middle_container, orient=Tkinter.VERTICAL, command=self.display_message_output.yview)
		self.display_message_output["yscrollcommand"] = self.vertical_scrollbar_out.set
		self.vertical_scrollbar_out.pack(side=Tkinter.LEFT, fill="y")	
		self.display_message_output.pack(side=Tkinter.LEFT, fill="x")
		
		#**** los mensajes que recibimos **************
		#----------------------------------------------
		#**** received messages ***********************
		self.display_message_input = Tkinter.Text(self.middle_container)
		self.display_message_input["width"] = 30
		self.display_message_input["height"] = 20
		self.display_message_input["wrap"] = "word"
		self.vertical_scrollbar_in = Tkinter.Scrollbar(self.middle_container, orient=Tkinter.VERTICAL, command=self.display_message_input.yview)
		self.display_message_input["yscrollcommand"] = self.vertical_scrollbar_in.set
		self.vertical_scrollbar_in.pack(side=Tkinter.RIGHT, fill="y")	
		self.display_message_input.pack(side=Tkinter.RIGHT, fill="x")
		
		#**** botones muy usados **********************
		#----------------------------------------------
		#**** widely used buttons *********************
		self.button_send = Tkinter.Button(self.bottom_container)
		self.button_send["text"] = _("Send")
		self.button_send["width"] = "50"
		self.button_send.bind("<1>", self.x_send)
		self.button_send.pack()

		
		#**** Menu ************************************
		self.mnu = Tkinter.Menu(self.Parent)
		self.Parent.config(menu=self.mnu)

		self.mnuFile = Tkinter.Menu()
		self.mnu.add_cascade(label= _("File"), menu=self.mnuFile)
		self.mnuFile.add_command(label= _("View log"), command=self.view_log)
		self.mnuFile.add_separator()
		self.mnuFile.add_command(label= _("Exit"), command=exit)
		
		self.mnuTools = Tkinter.Menu()
		self.mnu.add_cascade(label= _("Tools"), menu=self.mnuTools)
		self.mnuTools.add_command(label= _("View/Change nick"), command=self.change_nick)
		self.mnuTools.add_command(label= _("List online"), command=self.list_peers)
		
		self.mnuHelp = Tkinter.Menu()
		self.mnu.add_cascade(label=  _("Help"), menu=self.mnuHelp)
		self.mnuHelp.add_command(label="Contenidos", command=self.helpSpa)
		self.mnuHelp.add_command(label="Contents", command=self.helpEng)
		self.mnuHelp.add_separator()
		self.mnuHelp.add_command(label= _("About lanChat"), command=self.version)
		
		self.thread_listen.start()
		self.Parent.mainloop()


	def dialog(self, Title, Text):
		root_dialog = Tkinter.Toplevel()
		root_dialog.title(Title)
		root_dialog.geometry("400x250")
		root_dialog.resizable(False, False)

		frame1 = Tkinter.Frame(root_dialog)
		frame1.pack()
		frame2 = Tkinter.Frame(root_dialog)
		frame2.pack()
		
		display_message_dialog = Tkinter.Text(frame1)
		display_message_dialog["width"] = 65
		display_message_dialog["height"] = 14
		display_message_dialog["wrap"] = "word"
		
		vertical_scrollbar = Tkinter.Scrollbar(frame1, orient=Tkinter.VERTICAL, command=display_message_dialog.yview)
		display_message_dialog["yscrollcommand"] = vertical_scrollbar.set
		vertical_scrollbar.pack(side=Tkinter.RIGHT, fill="y")	
		display_message_dialog.pack(side=Tkinter.LEFT)
		

		def close_dlg(event):
			root_dialog.destroy()

		button_close = Tkinter.Button(frame2)
		button_close["text"] = " OK "
		button_close["width"] = "40"
		button_close.bind("<1>", close_dlg)
		button_close.pack(side= Tkinter.BOTTOM)
		display_message_dialog.insert(Tkinter.END, Text)


	def help_(self, lang):
		file_help = open(os.path.realpath("data/hlp-" + lang + ".txt"), "rt")
		file_data = ""
		while True:
			line = file_help.readline() 
			if not line:
				break
			file_data += line 
		self.dialog( _("Contents"), file_data)
		file_help.close()
		

	def helpSpa(self):
		self.help_("es")


	def helpEng(self):
		self.help_("en")


	def view_log(self):
		file_log = open(os.path.realpath("data/logs/client.log"), "rt")
		file_data = ""
		while True:
			line = file_log.readline() 
			if not line:
				break
			file_data += line 
		self.dialog( _("Log viewer"), file_data)
		file_log.close()


	def write_log(self, message, taking_date):
		now = time.strftime("%Y-%m-%d %H:%M:%S")
		line = ""

		if taking_date == False:
			line = message
		else:
			line = "\n" + now + " " + message

		file_log = open(os.path.realpath("data/logs/client.log"), "at+")
		file_log.write(line)
		file_log.close()


	def update_nick(self):
		file_nick = open(os.path.realpath("data/config/nick.txt"), "r")
		self.nick = file_nick.readline()
		file_nick.close()


	def change_nick(self):
		root_dialog = Tkinter.Toplevel()
		root_dialog.title( _("View/change nick") )
		root_dialog.geometry("300x80")
		root_dialog.resizable(False, False)
		
		frame1 = Tkinter.Frame(root_dialog)
		frame1.pack()
		
		frame2 = Tkinter.Frame(root_dialog)
		frame2.pack()
		
		file_nick = open(os.path.realpath("data/config/nick.txt"), "rt")
		tmpNick = file_nick.readline()
		file_nick.close()

		label = Tkinter.Label(frame1, text = "Actual: " + tmpNick + "  ") 
		label.pack(side=Tkinter.LEFT)

		entry = Tkinter.Entry(frame1)
		entry["width"] = 50
		entry.pack(fill="y")
		
		def ok_click(event):
			file_nick = open(os.path.realpath("data/config/nick.txt"), "wt")
			file_nick.write(entry.get())
			file_nick.close()
			root_dialog.destroy()
			self.update_nick()
			self.make_client()

		def cancel_click(event):
			root_dialog.destroy()

		button_ok = Tkinter.Button(frame2)
		button_ok["text"] = "OK"
		button_ok["width"] = 25
		button_ok.bind("<1>", ok_click)
		button_ok.pack(side=Tkinter.LEFT)
		
		button_cancel = Tkinter.Button(frame2)
		button_cancel["text"] = _("Cancel")
		button_cancel["width"] = 25
		button_cancel.bind("<1>", cancel_click)
		button_cancel.pack(side=Tkinter.RIGHT)


	def version(self):
		msg="lanChat "+self.Version+" - " + _("Local Area Network Chat system\n\n2012(C) Abel Sendon abelnicolas1976@gmail.com\nThis program is free software, you can use, modify o distribute it under terms of the GNU v2 or later, view COPYING for more details.")
		self.dialog( _("About program"), msg)


	def make_client(self):
		#**** Si hay un socket abierto se cierra ******
		#----------------------------------------------
		#**** if there is a open socket, close it *****
		try:
			self.client_socket.shutdown()
			self.client_socket.close()
			self.client_socket = None 
		except:
			pass  

		self.client_socket  = socket.socket(socket.AF_INET, socket.SOCK_STREAM)
		self.client_socket.setsockopt(socket.IPPROTO_TCP, socket.TCP_NODELAY, 1)
		try:
			self.ip, self.port = self.client_socket.getsockname()
		except:
			pass

		for i in range(len(self.hosts)):
			try:
				self.client_socket.connect((self.hosts[i], 8000))
				self.client_socket.send(self.nick)
				msg = _("Connected to ") + self.hosts[i] + _(", nick: ") + self.nick
				print msg
				self.write_log(msg, True)
				time.sleep(1)
				self.send("\n")
				return True
			except:
				print _("Cannot connect to %s") % self.hosts[i]


	def sound_player(self, Snd):
		pygame.mixer.init()
		pygame.mixer.music.load(os.path.realpath("data/snd/lanchat-"+Snd+".ogg"))
		pygame.mixer.music.play()
		while pygame.mixer.music.get_busy():
			pass
		return


	def sound_beep(self):	
		self.sound_player("beep")


	def sound_error(self):
		self.sound_player("error")


	def quit(self,event):
		try:
			self.thread_listen.stop = True
			self.client_socket.shutdown()
			self.client_socket.close()
			del self.client_socket.close
		except:
			self.Parent.destroy()
			exit(1)
		self.Parent.destroy()
		exit(0)


	def list_peers(self):
		self.client_socket.send("LSPEERS")
		return


	def send(self, msg):
		self.write_log( _("Sent from client: ") + msg, True)
		try:
			self.client_socket.send(msg)
			print _("Sent %s") % msg
		except:
			self.make_client() 


	def x_send(self,event):
		self.send(self.display_message_output.get("1.0", Tkinter.END))
		self.display_message_output.delete("1.0", Tkinter.END)


	def listen_messages(self):
		while 1:
			time.sleep(2)
			try:
				data = str(self.client_socket.recv(2048))
				#thread_beep = threading.Thread(target=self.sound_beep, args=())
				#thread_beep.start()
				self.client_socket.send("---")
							
				if ("LSPEERS=" in data):
					tmpData = data[8:]
					data = _("\nOnline: ") + tmpData
				self.display_message_input.insert(Tkinter.END, data)
				self.write_log(data, False)

			except socket.error:
				print _("Read unsuccessful")
				#self.sound_error()
				self.make_client()


if __name__ == "__main__":
	app = lanchat()

